#include <assert.h>

#include <aterm2.h>
#include <deprecated.h>
#include "list.h"

/*{{{  typedefs */

typedef struct ATerm _Module;
typedef struct ATerm _Modules;
typedef struct ATerm _Modules2;
typedef struct ATerm _ModuleList;
typedef struct ATerm _Separated;
typedef struct ATerm _Layout;
typedef struct ATerm _NineSeps;

/*}}}  */

/*{{{  void initListApi(void) */

void initListApi(void)
{
  init_list_dict();
}

/*}}}  */

/*{{{  term conversion functions */

/*{{{  Module ModuleFromTerm(ATerm t) */

Module ModuleFromTerm(ATerm t)
{
  return (Module)t;
}

/*}}}  */
/*{{{  ATerm ModuleToTerm(Module arg) */

ATerm ModuleToTerm(Module arg)
{
  return (ATerm)arg;
}

/*}}}  */
/*{{{  Modules ModulesFromTerm(ATerm t) */

Modules ModulesFromTerm(ATerm t)
{
  return (Modules)t;
}

/*}}}  */
/*{{{  ATerm ModulesToTerm(Modules arg) */

ATerm ModulesToTerm(Modules arg)
{
  return (ATerm)arg;
}

/*}}}  */
/*{{{  Modules2 Modules2FromTerm(ATerm t) */

Modules2 Modules2FromTerm(ATerm t)
{
  return (Modules2)t;
}

/*}}}  */
/*{{{  ATerm Modules2ToTerm(Modules2 arg) */

ATerm Modules2ToTerm(Modules2 arg)
{
  return (ATerm)arg;
}

/*}}}  */
/*{{{  ModuleList ModuleListFromTerm(ATerm t) */

ModuleList ModuleListFromTerm(ATerm t)
{
  return (ModuleList)t;
}

/*}}}  */
/*{{{  ATerm ModuleListToTerm(ModuleList arg) */

ATerm ModuleListToTerm(ModuleList arg)
{
  return (ATerm)arg;
}

/*}}}  */
/*{{{  Separated SeparatedFromTerm(ATerm t) */

Separated SeparatedFromTerm(ATerm t)
{
  return (Separated)t;
}

/*}}}  */
/*{{{  ATerm SeparatedToTerm(Separated arg) */

ATerm SeparatedToTerm(Separated arg)
{
  return (ATerm)arg;
}

/*}}}  */
/*{{{  Layout LayoutFromTerm(ATerm t) */

Layout LayoutFromTerm(ATerm t)
{
  return (Layout)t;
}

/*}}}  */
/*{{{  ATerm LayoutToTerm(Layout arg) */

ATerm LayoutToTerm(Layout arg)
{
  return (ATerm)arg;
}

/*}}}  */
/*{{{  NineSeps NineSepsFromTerm(ATerm t) */

NineSeps NineSepsFromTerm(ATerm t)
{
  return (NineSeps)t;
}

/*}}}  */
/*{{{  ATerm NineSepsToTerm(NineSeps arg) */

ATerm NineSepsToTerm(NineSeps arg)
{
  return (ATerm)arg;
}

/*}}}  */

/*}}}  */
/*{{{  list functions */

int getModulesLength (Modules arg) {
  return ATgetLength((ATermList) arg);
}
Modules reverseModules(Modules arg) {
  return (Modules) ATreverse((ATermList) arg);
}
Modules appendModules(Modules arg, Module elem) {
  return (Modules) ATappend((ATermList) arg, (ATerm) elem);
}
Modules concatModules(Modules arg0, Modules arg1) {
  return (Modules) ATconcat((ATermList) arg0, (ATermList) arg1);
}
Modules sliceModules(Modules arg, int start, int end) {
  return (Modules) ATgetSlice((ATermList) arg, start, end);
}
Module getModulesModuleAt(Modules arg, int index) {
 return (Module) ATelementAt((ATermList) arg, index);
}
Modules replaceModulesModuleAt(Modules arg, Module elem, int index) {
 return (Modules) ATreplace((ATermList) arg, (ATerm) elem, index);
}
Modules makeModules1(Module elem1) {
  return (Modules) ATmakeList1((ATerm) elem1);
}
Modules makeModules2(Module elem1, Module elem2) {
  return (Modules) ATmakeList2((ATerm) elem1, (ATerm) elem2);
}
Modules makeModules3(Module elem1, Module elem2, Module elem3) {
  return (Modules) ATmakeList3((ATerm) elem1, (ATerm) elem2, (ATerm) elem3);
}
Modules makeModules4(Module elem1, Module elem2, Module elem3, Module elem4) {
  return (Modules) ATmakeList4((ATerm) elem1, (ATerm) elem2, (ATerm) elem3, (ATerm) elem4);
}
Modules makeModules5(Module elem1, Module elem2, Module elem3, Module elem4, Module elem5) {
  return (Modules) ATmakeList5((ATerm) elem1, (ATerm) elem2, (ATerm) elem3, (ATerm) elem4, (ATerm) elem5);
}
Modules makeModules6(Module elem1, Module elem2, Module elem3, Module elem4, Module elem5, Module elem6) {
  return (Modules) ATmakeList6((ATerm) elem1, (ATerm) elem2, (ATerm) elem3, (ATerm) elem4, (ATerm) elem5, (ATerm) elem6);
}
int getModules2Length (Modules2 arg) {
  return ATgetLength((ATermList) arg);
}
Modules2 reverseModules2(Modules2 arg) {
  return (Modules2) ATreverse((ATermList) arg);
}
Modules2 appendModules2(Modules2 arg, Module elem) {
  return (Modules2) ATappend((ATermList) arg, (ATerm) elem);
}
Modules2 concatModules2(Modules2 arg0, Modules2 arg1) {
  return (Modules2) ATconcat((ATermList) arg0, (ATermList) arg1);
}
Modules2 sliceModules2(Modules2 arg, int start, int end) {
  return (Modules2) ATgetSlice((ATermList) arg, start, end);
}
Module getModules2ModuleAt(Modules2 arg, int index) {
 return (Module) ATelementAt((ATermList) arg, index);
}
Modules2 replaceModules2ModuleAt(Modules2 arg, Module elem, int index) {
 return (Modules2) ATreplace((ATermList) arg, (ATerm) elem, index);
}
Modules2 makeModules21(Module elem1) {
  return (Modules2) ATmakeList1((ATerm) elem1);
}
Modules2 makeModules22(Module elem1, Module elem2) {
  return (Modules2) ATmakeList2((ATerm) elem1, (ATerm) elem2);
}
Modules2 makeModules23(Module elem1, Module elem2, Module elem3) {
  return (Modules2) ATmakeList3((ATerm) elem1, (ATerm) elem2, (ATerm) elem3);
}
Modules2 makeModules24(Module elem1, Module elem2, Module elem3, Module elem4) {
  return (Modules2) ATmakeList4((ATerm) elem1, (ATerm) elem2, (ATerm) elem3, (ATerm) elem4);
}
Modules2 makeModules25(Module elem1, Module elem2, Module elem3, Module elem4, Module elem5) {
  return (Modules2) ATmakeList5((ATerm) elem1, (ATerm) elem2, (ATerm) elem3, (ATerm) elem4, (ATerm) elem5);
}
Modules2 makeModules26(Module elem1, Module elem2, Module elem3, Module elem4, Module elem5, Module elem6) {
  return (Modules2) ATmakeList6((ATerm) elem1, (ATerm) elem2, (ATerm) elem3, (ATerm) elem4, (ATerm) elem5, (ATerm) elem6);
}
int getSeparatedLength (Separated arg) {
  if (ATisEmpty((ATermList) arg)) {
    return 0;
  }
  return (ATgetLength((ATermList) arg) / 4) + 1;
}
Separated appendSeparated(Separated arg0, Layout wsl, Layout wsr, Module arg1) {
  return concatSeparated(arg0, wsl, wsr, makeSeparatedSingle(arg1));
}
Separated concatSeparated(Separated arg0, Layout wsl, Layout wsr, Separated arg1) {
  if (ATisEmpty((ATermList) arg0)) {
    return arg1;
  }
  arg1 = makeSeparatedMany((Module)ATgetFirst((ATermList) arg0), wsl, wsr,  arg1);
  arg1 = (Separated) ATgetNext((ATermList) arg1);
  return (Separated) ATconcat((ATermList) arg0, (ATermList) arg1);
}
Separated reverseSeparated(Separated arg) {
  ATermList list = (ATermList) arg;
  ATerm head;
  ATerm sep0;
  ATerm sep1;
  ATerm sep2;
  ATermList result;

 if (ATisEmpty(list) || ATgetLength(list) == 1) {
    return arg;
  }

  result = ATmakeList1(ATgetFirst(list));
      list = ATgetNext(list);
  sep0 = ATgetFirst(list);
  list = ATgetNext(list);
  sep1 = ATgetFirst(list);
  list = ATgetNext(list);
  sep2 = ATgetFirst(list);
  list = ATgetNext(list);

  while (!ATisEmpty(list)) {
    result = ATinsert(result, sep2);
    result = ATinsert(result, sep1);
    result = ATinsert(result, sep0);

   head = ATgetFirst(list);
   result = ATinsert(result, head);
    list = ATgetNext(list);

   if (!ATisEmpty(list)) {
  sep0 = ATgetFirst(list);
  list = ATgetNext(list);
  sep1 = ATgetFirst(list);
  list = ATgetNext(list);
  sep2 = ATgetFirst(list);
  list = ATgetNext(list);
   }
  }

  return (Separated) result;
}
int getNineSepsLength (NineSeps arg) {
  if (ATisEmpty((ATermList) arg)) {
    return 0;
  }
  return (ATgetLength((ATermList) arg) / 10) + 1;
}
NineSeps appendNineSeps(NineSeps arg0, Module arg1) {
  return concatNineSeps(arg0, makeNineSepsSingle(arg1));
}
NineSeps concatNineSeps(NineSeps arg0, NineSeps arg1) {
  if (ATisEmpty((ATermList) arg0)) {
    return arg1;
  }
  arg1 = makeNineSepsMany((Module)ATgetFirst((ATermList) arg0),  arg1);
  arg1 = (NineSeps) ATgetNext((ATermList) arg1);
  return (NineSeps) ATconcat((ATermList) arg0, (ATermList) arg1);
}
NineSeps reverseNineSeps(NineSeps arg) {
  ATermList list = (ATermList) arg;
  ATerm head;
  ATerm sep0;
  ATerm sep1;
  ATerm sep2;
  ATerm sep3;
  ATerm sep4;
  ATerm sep5;
  ATerm sep6;
  ATerm sep7;
  ATerm sep8;
  ATermList result;

 if (ATisEmpty(list) || ATgetLength(list) == 1) {
    return arg;
  }

  result = ATmakeList1(ATgetFirst(list));
      list = ATgetNext(list);
  sep0 = ATgetFirst(list);
  list = ATgetNext(list);
  sep1 = ATgetFirst(list);
  list = ATgetNext(list);
  sep2 = ATgetFirst(list);
  list = ATgetNext(list);
  sep3 = ATgetFirst(list);
  list = ATgetNext(list);
  sep4 = ATgetFirst(list);
  list = ATgetNext(list);
  sep5 = ATgetFirst(list);
  list = ATgetNext(list);
  sep6 = ATgetFirst(list);
  list = ATgetNext(list);
  sep7 = ATgetFirst(list);
  list = ATgetNext(list);
  sep8 = ATgetFirst(list);
  list = ATgetNext(list);

  while (!ATisEmpty(list)) {
    result = ATinsert(result, sep8);
    result = ATinsert(result, sep7);
    result = ATinsert(result, sep6);
    result = ATinsert(result, sep5);
    result = ATinsert(result, sep4);
    result = ATinsert(result, sep3);
    result = ATinsert(result, sep2);
    result = ATinsert(result, sep1);
    result = ATinsert(result, sep0);

   head = ATgetFirst(list);
   result = ATinsert(result, head);
    list = ATgetNext(list);

   if (!ATisEmpty(list)) {
  sep0 = ATgetFirst(list);
  list = ATgetNext(list);
  sep1 = ATgetFirst(list);
  list = ATgetNext(list);
  sep2 = ATgetFirst(list);
  list = ATgetNext(list);
  sep3 = ATgetFirst(list);
  list = ATgetNext(list);
  sep4 = ATgetFirst(list);
  list = ATgetNext(list);
  sep5 = ATgetFirst(list);
  list = ATgetNext(list);
  sep6 = ATgetFirst(list);
  list = ATgetNext(list);
  sep7 = ATgetFirst(list);
  list = ATgetNext(list);
  sep8 = ATgetFirst(list);
  list = ATgetNext(list);
   }
  }

  return (NineSeps) result;
}

/*}}}  */
/*{{{  constructors */

/*{{{  Module makeModuleDefault(char* string) */

Module makeModuleDefault(char* string)
{
  return (Module)(ATerm)ATmakeAppl0(ATmakeAFun(string, 0, ATtrue));
}

/*}}}  */
/*{{{  Modules makeModulesMany(Module head, Modules tail) */

Modules makeModulesMany(Module head, Modules tail)
{
  return (Modules)(ATerm)ATinsert((ATermList)tail, (ATerm)head);
}

/*}}}  */
/*{{{  Modules makeModulesEmpty() */

Modules makeModulesEmpty()
{
  return (Modules)(ATerm)ATempty;
}

/*}}}  */
/*{{{  Modules2 makeModules2Many(Module head, Modules2 tail) */

Modules2 makeModules2Many(Module head, Modules2 tail)
{
  return (Modules2)(ATerm)ATinsert((ATermList)tail, (ATerm)head);
}

/*}}}  */
/*{{{  Modules2 makeModules2Empty() */

Modules2 makeModules2Empty()
{
  return (Modules2)(ATerm)ATempty;
}

/*}}}  */
/*{{{  ModuleList makeModuleListModules(Modules modules) */

ModuleList makeModuleListModules(Modules modules)
{
  return (ModuleList)(ATerm)ATmakeAppl1(afun0, (ATerm)modules);
}

/*}}}  */
/*{{{  Separated makeSeparatedMany(Module head, Layout wsl, Layout wsr, Separated tail) */

Separated makeSeparatedMany(Module head, Layout wsl, Layout wsr, Separated tail)
{
  if (isSeparatedEmpty(tail)) {
    return makeSeparatedSingle(head);
  }
  return (Separated)(ATerm)ATinsert(ATinsert(ATinsert(ATinsert((ATermList)tail, (ATerm)ATmakeAppl1(afun1, (ATerm)wsr)), (ATerm)ATmakeAppl0(afun2)), (ATerm)ATmakeAppl1(afun1, (ATerm)wsl)), (ATerm)head);
}

/*}}}  */
/*{{{  Separated makeSeparatedEmpty() */

Separated makeSeparatedEmpty()
{
  return (Separated)(ATerm)ATempty;
}

/*}}}  */
/*{{{  Separated makeSeparatedSingle(Module head) */

Separated makeSeparatedSingle(Module head)
{
  return (Separated)(ATerm)ATmakeList1((ATerm)head);
}

/*}}}  */
/*{{{  Layout makeLayoutDefault(char* string) */

Layout makeLayoutDefault(char* string)
{
  return (Layout)(ATerm)ATmakeAppl0(ATmakeAFun(string, 0, ATtrue));
}

/*}}}  */
/*{{{  NineSeps makeNineSepsMany(Module head, NineSeps tail) */

NineSeps makeNineSepsMany(Module head, NineSeps tail)
{
  if (isNineSepsEmpty(tail)) {
    return makeNineSepsSingle(head);
  }
  return (NineSeps)(ATerm)ATinsert(ATinsert(ATinsert(ATinsert(ATinsert(ATinsert(ATinsert(ATinsert(ATinsert(ATinsert((ATermList)tail, (ATerm)ATmakeInt(9)), (ATerm)ATmakeInt(8)), (ATerm)ATmakeInt(7)), (ATerm)ATmakeInt(6)), (ATerm)ATmakeInt(5)), (ATerm)ATmakeInt(4)), (ATerm)ATmakeInt(3)), (ATerm)ATmakeInt(2)), (ATerm)ATmakeInt(1)), (ATerm)head);
}

/*}}}  */
/*{{{  NineSeps makeNineSepsEmpty() */

NineSeps makeNineSepsEmpty()
{
  return (NineSeps)(ATerm)ATempty;
}

/*}}}  */
/*{{{  NineSeps makeNineSepsSingle(Module head) */

NineSeps makeNineSepsSingle(Module head)
{
  return (NineSeps)(ATerm)ATmakeList1((ATerm)head);
}

/*}}}  */

/*}}}  */
/*{{{  equality functions */

ATbool isEqualModule(Module arg0, Module arg1)
{
  return ATisEqual((ATerm)arg0, (ATerm)arg1);
}

ATbool isEqualModules(Modules arg0, Modules arg1)
{
  return ATisEqual((ATerm)arg0, (ATerm)arg1);
}

ATbool isEqualModules2(Modules2 arg0, Modules2 arg1)
{
  return ATisEqual((ATerm)arg0, (ATerm)arg1);
}

ATbool isEqualModuleList(ModuleList arg0, ModuleList arg1)
{
  return ATisEqual((ATerm)arg0, (ATerm)arg1);
}

ATbool isEqualSeparated(Separated arg0, Separated arg1)
{
  return ATisEqual((ATerm)arg0, (ATerm)arg1);
}

ATbool isEqualLayout(Layout arg0, Layout arg1)
{
  return ATisEqual((ATerm)arg0, (ATerm)arg1);
}

ATbool isEqualNineSeps(NineSeps arg0, NineSeps arg1)
{
  return ATisEqual((ATerm)arg0, (ATerm)arg1);
}

/*}}}  */
/*{{{  Module accessors */

/*{{{  ATbool isValidModule(Module arg) */

ATbool isValidModule(Module arg)
{
  if (isModuleDefault(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  inline ATbool isModuleDefault(Module arg) */

inline ATbool isModuleDefault(Module arg)
{
#ifndef DISABLE_DYNAMIC_CHECKING
  assert(arg != NULL);
  assert(ATmatchTerm((ATerm)arg, patternModuleDefault, NULL));
#endif
  return ATtrue;
}

/*}}}  */
/*{{{  ATbool hasModuleString(Module arg) */

ATbool hasModuleString(Module arg)
{
  if (isModuleDefault(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  char* getModuleString(Module arg) */

char* getModuleString(Module arg)
{
  
    return (char*)ATgetName(ATgetAFun((ATermAppl)arg));
}

/*}}}  */
/*{{{  Module setModuleString(Module arg, char* string) */

Module setModuleString(Module arg, char* string)
{
  if (isModuleDefault(arg)) {
    return (Module)ATmakeAppl0(ATmakeAFun(string, 0, ATtrue));
  }

  ATabort("Module has no String: %t\n", arg);
  return (Module)NULL;
}

/*}}}  */

/*}}}  */
/*{{{  Modules accessors */

/*{{{  ATbool isValidModules(Modules arg) */

ATbool isValidModules(Modules arg)
{
  if (isModulesMany(arg)) {
    return ATtrue;
  }
  else if (isModulesEmpty(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  inline ATbool isModulesMany(Modules arg) */

inline ATbool isModulesMany(Modules arg)
{
  if (ATisEmpty((ATermList)arg)) {
    return ATfalse;
  }
#ifndef DISABLE_DYNAMIC_CHECKING
  assert(arg != NULL);
  assert(ATmatchTerm((ATerm)arg, patternModulesMany, NULL, NULL));
#endif
  return ATtrue;
}

/*}}}  */
/*{{{  inline ATbool isModulesEmpty(Modules arg) */

inline ATbool isModulesEmpty(Modules arg)
{
  if (!ATisEmpty((ATermList)arg)) {
    return ATfalse;
  }
#ifndef DISABLE_DYNAMIC_CHECKING
  assert(arg != NULL);
  assert(ATmatchTerm((ATerm)arg, patternModulesEmpty));
#endif
  return ATtrue;
}

/*}}}  */
/*{{{  ATbool hasModulesHead(Modules arg) */

ATbool hasModulesHead(Modules arg)
{
  if (isModulesMany(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  Module getModulesHead(Modules arg) */

Module getModulesHead(Modules arg)
{
  
    return (Module)ATgetFirst((ATermList)arg);
}

/*}}}  */
/*{{{  Modules setModulesHead(Modules arg, Module head) */

Modules setModulesHead(Modules arg, Module head)
{
  if (isModulesMany(arg)) {
    return (Modules)ATreplace((ATermList)arg, (ATerm)head, 0);
  }

  ATabort("Modules has no Head: %t\n", arg);
  return (Modules)NULL;
}

/*}}}  */
/*{{{  ATbool hasModulesTail(Modules arg) */

ATbool hasModulesTail(Modules arg)
{
  if (isModulesMany(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  Modules getModulesTail(Modules arg) */

Modules getModulesTail(Modules arg)
{
  
    return (Modules)ATgetNext((ATermList)arg);
}

/*}}}  */
/*{{{  Modules setModulesTail(Modules arg, Modules tail) */

Modules setModulesTail(Modules arg, Modules tail)
{
  if (isModulesMany(arg)) {
    return (Modules)ATreplaceTail((ATermList)arg, (ATermList)tail, 1);
  }

  ATabort("Modules has no Tail: %t\n", arg);
  return (Modules)NULL;
}

/*}}}  */

/*}}}  */
/*{{{  Modules2 accessors */

/*{{{  ATbool isValidModules2(Modules2 arg) */

ATbool isValidModules2(Modules2 arg)
{
  if (isModules2Many(arg)) {
    return ATtrue;
  }
  else if (isModules2Empty(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  inline ATbool isModules2Many(Modules2 arg) */

inline ATbool isModules2Many(Modules2 arg)
{
  if (ATisEmpty((ATermList)arg)) {
    return ATfalse;
  }
#ifndef DISABLE_DYNAMIC_CHECKING
  assert(arg != NULL);
  assert(ATmatchTerm((ATerm)arg, patternModules2Many, NULL, NULL));
#endif
  return ATtrue;
}

/*}}}  */
/*{{{  inline ATbool isModules2Empty(Modules2 arg) */

inline ATbool isModules2Empty(Modules2 arg)
{
  if (!ATisEmpty((ATermList)arg)) {
    return ATfalse;
  }
#ifndef DISABLE_DYNAMIC_CHECKING
  assert(arg != NULL);
  assert(ATmatchTerm((ATerm)arg, patternModules2Empty));
#endif
  return ATtrue;
}

/*}}}  */
/*{{{  ATbool hasModules2Head(Modules2 arg) */

ATbool hasModules2Head(Modules2 arg)
{
  if (isModules2Many(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  Module getModules2Head(Modules2 arg) */

Module getModules2Head(Modules2 arg)
{
  
    return (Module)ATgetFirst((ATermList)arg);
}

/*}}}  */
/*{{{  Modules2 setModules2Head(Modules2 arg, Module head) */

Modules2 setModules2Head(Modules2 arg, Module head)
{
  if (isModules2Many(arg)) {
    return (Modules2)ATreplace((ATermList)arg, (ATerm)head, 0);
  }

  ATabort("Modules2 has no Head: %t\n", arg);
  return (Modules2)NULL;
}

/*}}}  */
/*{{{  ATbool hasModules2Tail(Modules2 arg) */

ATbool hasModules2Tail(Modules2 arg)
{
  if (isModules2Many(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  Modules2 getModules2Tail(Modules2 arg) */

Modules2 getModules2Tail(Modules2 arg)
{
  
    return (Modules2)ATgetNext((ATermList)arg);
}

/*}}}  */
/*{{{  Modules2 setModules2Tail(Modules2 arg, Modules2 tail) */

Modules2 setModules2Tail(Modules2 arg, Modules2 tail)
{
  if (isModules2Many(arg)) {
    return (Modules2)ATreplaceTail((ATermList)arg, (ATermList)tail, 1);
  }

  ATabort("Modules2 has no Tail: %t\n", arg);
  return (Modules2)NULL;
}

/*}}}  */

/*}}}  */
/*{{{  ModuleList accessors */

/*{{{  ATbool isValidModuleList(ModuleList arg) */

ATbool isValidModuleList(ModuleList arg)
{
  if (isModuleListModules(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  inline ATbool isModuleListModules(ModuleList arg) */

inline ATbool isModuleListModules(ModuleList arg)
{
#ifndef DISABLE_DYNAMIC_CHECKING
  assert(arg != NULL);
  assert(ATmatchTerm((ATerm)arg, patternModuleListModules, NULL));
#endif
  return ATtrue;
}

/*}}}  */
/*{{{  ATbool hasModuleListModules(ModuleList arg) */

ATbool hasModuleListModules(ModuleList arg)
{
  if (isModuleListModules(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  Modules getModuleListModules(ModuleList arg) */

Modules getModuleListModules(ModuleList arg)
{
  
    return (Modules)ATgetArgument((ATermAppl)arg, 0);
}

/*}}}  */
/*{{{  ModuleList setModuleListModules(ModuleList arg, Modules modules) */

ModuleList setModuleListModules(ModuleList arg, Modules modules)
{
  if (isModuleListModules(arg)) {
    return (ModuleList)ATsetArgument((ATermAppl)arg, (ATerm)modules, 0);
  }

  ATabort("ModuleList has no Modules: %t\n", arg);
  return (ModuleList)NULL;
}

/*}}}  */

/*}}}  */
/*{{{  Separated accessors */

/*{{{  ATbool isValidSeparated(Separated arg) */

ATbool isValidSeparated(Separated arg)
{
  if (isSeparatedMany(arg)) {
    return ATtrue;
  }
  else if (isSeparatedEmpty(arg)) {
    return ATtrue;
  }
  else if (isSeparatedSingle(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  inline ATbool isSeparatedMany(Separated arg) */

inline ATbool isSeparatedMany(Separated arg)
{
  if (ATisEmpty((ATermList)arg)) {
    return ATfalse;
  }
  {
    static ATerm last_arg = NULL;
    static int last_gc = -1;
    static ATbool last_result;

    assert(arg != NULL);

    if (last_gc != ATgetGCCount() || (ATerm)arg != last_arg) {
      last_arg = (ATerm)arg;
      last_result = ATmatchTerm((ATerm)arg, patternSeparatedMany, NULL, NULL, NULL, NULL);
      last_gc = ATgetGCCount();
    }

    return last_result;
  }
}

/*}}}  */
/*{{{  inline ATbool isSeparatedEmpty(Separated arg) */

inline ATbool isSeparatedEmpty(Separated arg)
{
  if (!ATisEmpty((ATermList)arg)) {
    return ATfalse;
  }
#ifndef DISABLE_DYNAMIC_CHECKING
  assert(arg != NULL);
  assert(ATmatchTerm((ATerm)arg, patternSeparatedEmpty));
#endif
  return ATtrue;
}

/*}}}  */
/*{{{  inline ATbool isSeparatedSingle(Separated arg) */

inline ATbool isSeparatedSingle(Separated arg)
{
  if (ATisEmpty((ATermList)arg)) {
    return ATfalse;
  }
  {
    static ATerm last_arg = NULL;
    static int last_gc = -1;
    static ATbool last_result;

    assert(arg != NULL);

    if (last_gc != ATgetGCCount() || (ATerm)arg != last_arg) {
      last_arg = (ATerm)arg;
      last_result = ATmatchTerm((ATerm)arg, patternSeparatedSingle, NULL);
      last_gc = ATgetGCCount();
    }

    return last_result;
  }
}

/*}}}  */
/*{{{  ATbool hasSeparatedHead(Separated arg) */

ATbool hasSeparatedHead(Separated arg)
{
  if (isSeparatedMany(arg)) {
    return ATtrue;
  }
  else if (isSeparatedSingle(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  Module getSeparatedHead(Separated arg) */

Module getSeparatedHead(Separated arg)
{
  if (isSeparatedMany(arg)) {
    return (Module)ATgetFirst((ATermList)arg);
  }
  else 
    return (Module)ATgetFirst((ATermList)arg);
}

/*}}}  */
/*{{{  Separated setSeparatedHead(Separated arg, Module head) */

Separated setSeparatedHead(Separated arg, Module head)
{
  if (isSeparatedMany(arg)) {
    return (Separated)ATreplace((ATermList)arg, (ATerm)head, 0);
  }
  else if (isSeparatedSingle(arg)) {
    return (Separated)ATreplace((ATermList)arg, (ATerm)head, 0);
  }

  ATabort("Separated has no Head: %t\n", arg);
  return (Separated)NULL;
}

/*}}}  */
/*{{{  ATbool hasSeparatedWsl(Separated arg) */

ATbool hasSeparatedWsl(Separated arg)
{
  if (isSeparatedMany(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  Layout getSeparatedWsl(Separated arg) */

Layout getSeparatedWsl(Separated arg)
{
  
    return (Layout)ATgetArgument((ATermAppl)ATelementAt((ATermList)arg, 1), 0);
}

/*}}}  */
/*{{{  Separated setSeparatedWsl(Separated arg, Layout wsl) */

Separated setSeparatedWsl(Separated arg, Layout wsl)
{
  if (isSeparatedMany(arg)) {
    return (Separated)ATreplace((ATermList)arg, (ATerm)ATsetArgument((ATermAppl)ATelementAt((ATermList)arg, 1), (ATerm)wsl, 0), 1);
  }

  ATabort("Separated has no Wsl: %t\n", arg);
  return (Separated)NULL;
}

/*}}}  */
/*{{{  ATbool hasSeparatedWsr(Separated arg) */

ATbool hasSeparatedWsr(Separated arg)
{
  if (isSeparatedMany(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  Layout getSeparatedWsr(Separated arg) */

Layout getSeparatedWsr(Separated arg)
{
  
    return (Layout)ATgetArgument((ATermAppl)ATelementAt((ATermList)arg, 3), 0);
}

/*}}}  */
/*{{{  Separated setSeparatedWsr(Separated arg, Layout wsr) */

Separated setSeparatedWsr(Separated arg, Layout wsr)
{
  if (isSeparatedMany(arg)) {
    return (Separated)ATreplace((ATermList)arg, (ATerm)ATsetArgument((ATermAppl)ATelementAt((ATermList)arg, 3), (ATerm)wsr, 0), 3);
  }

  ATabort("Separated has no Wsr: %t\n", arg);
  return (Separated)NULL;
}

/*}}}  */
/*{{{  ATbool hasSeparatedTail(Separated arg) */

ATbool hasSeparatedTail(Separated arg)
{
  if (isSeparatedMany(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  Separated getSeparatedTail(Separated arg) */

Separated getSeparatedTail(Separated arg)
{
  
    return (Separated)ATgetTail((ATermList)arg, 4);
}

/*}}}  */
/*{{{  Separated setSeparatedTail(Separated arg, Separated tail) */

Separated setSeparatedTail(Separated arg, Separated tail)
{
  if (isSeparatedMany(arg)) {
    return (Separated)ATreplaceTail((ATermList)arg, (ATermList)tail, 4);
  }

  ATabort("Separated has no Tail: %t\n", arg);
  return (Separated)NULL;
}

/*}}}  */

/*}}}  */
/*{{{  Layout accessors */

/*{{{  ATbool isValidLayout(Layout arg) */

ATbool isValidLayout(Layout arg)
{
  if (isLayoutDefault(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  inline ATbool isLayoutDefault(Layout arg) */

inline ATbool isLayoutDefault(Layout arg)
{
#ifndef DISABLE_DYNAMIC_CHECKING
  assert(arg != NULL);
  assert(ATmatchTerm((ATerm)arg, patternLayoutDefault, NULL));
#endif
  return ATtrue;
}

/*}}}  */
/*{{{  ATbool hasLayoutString(Layout arg) */

ATbool hasLayoutString(Layout arg)
{
  if (isLayoutDefault(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  char* getLayoutString(Layout arg) */

char* getLayoutString(Layout arg)
{
  
    return (char*)ATgetName(ATgetAFun((ATermAppl)arg));
}

/*}}}  */
/*{{{  Layout setLayoutString(Layout arg, char* string) */

Layout setLayoutString(Layout arg, char* string)
{
  if (isLayoutDefault(arg)) {
    return (Layout)ATmakeAppl0(ATmakeAFun(string, 0, ATtrue));
  }

  ATabort("Layout has no String: %t\n", arg);
  return (Layout)NULL;
}

/*}}}  */

/*}}}  */
/*{{{  NineSeps accessors */

/*{{{  ATbool isValidNineSeps(NineSeps arg) */

ATbool isValidNineSeps(NineSeps arg)
{
  if (isNineSepsMany(arg)) {
    return ATtrue;
  }
  else if (isNineSepsEmpty(arg)) {
    return ATtrue;
  }
  else if (isNineSepsSingle(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  inline ATbool isNineSepsMany(NineSeps arg) */

inline ATbool isNineSepsMany(NineSeps arg)
{
  if (ATisEmpty((ATermList)arg)) {
    return ATfalse;
  }
  {
    static ATerm last_arg = NULL;
    static int last_gc = -1;
    static ATbool last_result;

    assert(arg != NULL);

    if (last_gc != ATgetGCCount() || (ATerm)arg != last_arg) {
      last_arg = (ATerm)arg;
      last_result = ATmatchTerm((ATerm)arg, patternNineSepsMany, NULL, NULL);
      last_gc = ATgetGCCount();
    }

    return last_result;
  }
}

/*}}}  */
/*{{{  inline ATbool isNineSepsEmpty(NineSeps arg) */

inline ATbool isNineSepsEmpty(NineSeps arg)
{
  if (!ATisEmpty((ATermList)arg)) {
    return ATfalse;
  }
#ifndef DISABLE_DYNAMIC_CHECKING
  assert(arg != NULL);
  assert(ATmatchTerm((ATerm)arg, patternNineSepsEmpty));
#endif
  return ATtrue;
}

/*}}}  */
/*{{{  inline ATbool isNineSepsSingle(NineSeps arg) */

inline ATbool isNineSepsSingle(NineSeps arg)
{
  if (ATisEmpty((ATermList)arg)) {
    return ATfalse;
  }
  {
    static ATerm last_arg = NULL;
    static int last_gc = -1;
    static ATbool last_result;

    assert(arg != NULL);

    if (last_gc != ATgetGCCount() || (ATerm)arg != last_arg) {
      last_arg = (ATerm)arg;
      last_result = ATmatchTerm((ATerm)arg, patternNineSepsSingle, NULL);
      last_gc = ATgetGCCount();
    }

    return last_result;
  }
}

/*}}}  */
/*{{{  ATbool hasNineSepsHead(NineSeps arg) */

ATbool hasNineSepsHead(NineSeps arg)
{
  if (isNineSepsMany(arg)) {
    return ATtrue;
  }
  else if (isNineSepsSingle(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  Module getNineSepsHead(NineSeps arg) */

Module getNineSepsHead(NineSeps arg)
{
  if (isNineSepsMany(arg)) {
    return (Module)ATgetFirst((ATermList)arg);
  }
  else 
    return (Module)ATgetFirst((ATermList)arg);
}

/*}}}  */
/*{{{  NineSeps setNineSepsHead(NineSeps arg, Module head) */

NineSeps setNineSepsHead(NineSeps arg, Module head)
{
  if (isNineSepsMany(arg)) {
    return (NineSeps)ATreplace((ATermList)arg, (ATerm)head, 0);
  }
  else if (isNineSepsSingle(arg)) {
    return (NineSeps)ATreplace((ATermList)arg, (ATerm)head, 0);
  }

  ATabort("NineSeps has no Head: %t\n", arg);
  return (NineSeps)NULL;
}

/*}}}  */
/*{{{  ATbool hasNineSepsTail(NineSeps arg) */

ATbool hasNineSepsTail(NineSeps arg)
{
  if (isNineSepsMany(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  NineSeps getNineSepsTail(NineSeps arg) */

NineSeps getNineSepsTail(NineSeps arg)
{
  
    return (NineSeps)ATgetTail((ATermList)arg, 10);
}

/*}}}  */
/*{{{  NineSeps setNineSepsTail(NineSeps arg, NineSeps tail) */

NineSeps setNineSepsTail(NineSeps arg, NineSeps tail)
{
  if (isNineSepsMany(arg)) {
    return (NineSeps)ATreplaceTail((ATermList)arg, (ATermList)tail, 10);
  }

  ATabort("NineSeps has no Tail: %t\n", arg);
  return (NineSeps)NULL;
}

/*}}}  */

/*}}}  */
/*{{{  sort visitors */

/*{{{  Module visitModule(Module arg, char* (*acceptString)(char*)) */

Module visitModule(Module arg, char* (*acceptString)(char*))
{
  if (isModuleDefault(arg)) {
    return makeModuleDefault(
        acceptString ? acceptString(getModuleString(arg)) : getModuleString(arg));
  }
  ATabort("not a Module: %t\n", arg);
  return (Module)NULL;
}

/*}}}  */
/*{{{  Modules visitModules(Modules arg, Module (*acceptHead)(Module)) */

Modules visitModules(Modules arg, Module (*acceptHead)(Module))
{
  if (isModulesMany(arg)) {
    return makeModulesMany(
        acceptHead ? acceptHead(getModulesHead(arg)) : getModulesHead(arg),
        visitModules(getModulesTail(arg), acceptHead));
  }
  if (isModulesEmpty(arg)) {
    return makeModulesEmpty();
  }
  ATabort("not a Modules: %t\n", arg);
  return (Modules)NULL;
}

/*}}}  */
/*{{{  Modules2 visitModules2(Modules2 arg, Module (*acceptHead)(Module)) */

Modules2 visitModules2(Modules2 arg, Module (*acceptHead)(Module))
{
  if (isModules2Many(arg)) {
    return makeModules2Many(
        acceptHead ? acceptHead(getModules2Head(arg)) : getModules2Head(arg),
        visitModules2(getModules2Tail(arg), acceptHead));
  }
  if (isModules2Empty(arg)) {
    return makeModules2Empty();
  }
  ATabort("not a Modules2: %t\n", arg);
  return (Modules2)NULL;
}

/*}}}  */
/*{{{  ModuleList visitModuleList(ModuleList arg, Modules (*acceptModules)(Modules)) */

ModuleList visitModuleList(ModuleList arg, Modules (*acceptModules)(Modules))
{
  if (isModuleListModules(arg)) {
    return makeModuleListModules(
        acceptModules ? acceptModules(getModuleListModules(arg)) : getModuleListModules(arg));
  }
  ATabort("not a ModuleList: %t\n", arg);
  return (ModuleList)NULL;
}

/*}}}  */
/*{{{  Separated visitSeparated(Separated arg, Module (*acceptHead)(Module), Layout (*acceptWsl)(Layout), Layout (*acceptWsr)(Layout)) */

Separated visitSeparated(Separated arg, Module (*acceptHead)(Module), Layout (*acceptWsl)(Layout), Layout (*acceptWsr)(Layout))
{
  if (isSeparatedMany(arg)) {
    return makeSeparatedMany(
        acceptHead ? acceptHead(getSeparatedHead(arg)) : getSeparatedHead(arg),
        acceptWsl ? acceptWsl(getSeparatedWsl(arg)) : getSeparatedWsl(arg),
        acceptWsr ? acceptWsr(getSeparatedWsr(arg)) : getSeparatedWsr(arg),
        visitSeparated(getSeparatedTail(arg), acceptHead, acceptWsl, acceptWsr));
  }
  if (isSeparatedEmpty(arg)) {
    return makeSeparatedEmpty();
  }
  if (isSeparatedSingle(arg)) {
    return makeSeparatedSingle(
        acceptHead ? acceptHead(getSeparatedHead(arg)) : getSeparatedHead(arg));
  }
  ATabort("not a Separated: %t\n", arg);
  return (Separated)NULL;
}

/*}}}  */
/*{{{  Layout visitLayout(Layout arg, char* (*acceptString)(char*)) */

Layout visitLayout(Layout arg, char* (*acceptString)(char*))
{
  if (isLayoutDefault(arg)) {
    return makeLayoutDefault(
        acceptString ? acceptString(getLayoutString(arg)) : getLayoutString(arg));
  }
  ATabort("not a Layout: %t\n", arg);
  return (Layout)NULL;
}

/*}}}  */
/*{{{  NineSeps visitNineSeps(NineSeps arg, Module (*acceptHead)(Module)) */

NineSeps visitNineSeps(NineSeps arg, Module (*acceptHead)(Module))
{
  if (isNineSepsMany(arg)) {
    return makeNineSepsMany(
        acceptHead ? acceptHead(getNineSepsHead(arg)) : getNineSepsHead(arg),
        visitNineSeps(getNineSepsTail(arg), acceptHead));
  }
  if (isNineSepsEmpty(arg)) {
    return makeNineSepsEmpty();
  }
  if (isNineSepsSingle(arg)) {
    return makeNineSepsSingle(
        acceptHead ? acceptHead(getNineSepsHead(arg)) : getNineSepsHead(arg));
  }
  ATabort("not a NineSeps: %t\n", arg);
  return (NineSeps)NULL;
}

/*}}}  */

/*}}}  */
